<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDocumentosVendaERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDocumentosVendaERP
 * @subpackage Arrays
 */
class ArrayOfDocumentosVendaERP extends AbstractStructArrayBase
{
    /**
     * The DocumentosVendaERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DocumentosVendaERP[]
     */
    public $DocumentosVendaERP;
    /**
     * Constructor method for ArrayOfDocumentosVendaERP
     * @uses ArrayOfDocumentosVendaERP::setDocumentosVendaERP()
     * @param \StructType\DocumentosVendaERP[] $documentosVendaERP
     */
    public function __construct(array $documentosVendaERP = array())
    {
        $this
            ->setDocumentosVendaERP($documentosVendaERP);
    }
    /**
     * Get DocumentosVendaERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DocumentosVendaERP[]|null
     */
    public function getDocumentosVendaERP()
    {
        return isset($this->DocumentosVendaERP) ? $this->DocumentosVendaERP : null;
    }
    /**
     * Set DocumentosVendaERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DocumentosVendaERP[] $documentosVendaERP
     * @return \ArrayType\ArrayOfDocumentosVendaERP
     */
    public function setDocumentosVendaERP(array $documentosVendaERP = array())
    {
        foreach ($documentosVendaERP as $arrayOfDocumentosVendaERPDocumentosVendaERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfDocumentosVendaERPDocumentosVendaERPItem instanceof \StructType\DocumentosVendaERP) {
                throw new \InvalidArgumentException(sprintf('The DocumentosVendaERP property can only contain items of \StructType\DocumentosVendaERP, "%s" given', is_object($arrayOfDocumentosVendaERPDocumentosVendaERPItem) ? get_class($arrayOfDocumentosVendaERPDocumentosVendaERPItem) : gettype($arrayOfDocumentosVendaERPDocumentosVendaERPItem)), __LINE__);
            }
        }
        if (is_null($documentosVendaERP) || (is_array($documentosVendaERP) && empty($documentosVendaERP))) {
            unset($this->DocumentosVendaERP);
        } else {
            $this->DocumentosVendaERP = $documentosVendaERP;
        }
        return $this;
    }
    /**
     * Add item to DocumentosVendaERP value
     * @throws \InvalidArgumentException
     * @param \StructType\DocumentosVendaERP $item
     * @return \ArrayType\ArrayOfDocumentosVendaERP
     */
    public function addToDocumentosVendaERP(\StructType\DocumentosVendaERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DocumentosVendaERP) {
            throw new \InvalidArgumentException(sprintf('The DocumentosVendaERP property can only contain items of \StructType\DocumentosVendaERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DocumentosVendaERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DocumentosVendaERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DocumentosVendaERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DocumentosVendaERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DocumentosVendaERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DocumentosVendaERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DocumentosVendaERP
     */
    public function getAttributeName()
    {
        return 'DocumentosVendaERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDocumentosVendaERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
